local addonName, addon = ...
local TCL = addon.TomCatsLibs
local WorldMapFrame
local BattlefieldMapFrame
local FlightMapFrame

-- TODO: Add icons to the WorldMapFrame
-- TODO: Add icons to the BattleFieldMapFrame
-- TODO: Add icons to the FlightMapFrame
-- TODO: Add automatic routing
-- TODO: Draw route on the map
-- TODO: Add coins owned indicator + coins remaining to loot
-- TODO: Coins remaining indicator on the maps
-- TODO: Add holiday items available for purchase window
-- TODO: Add shortcut to achievements or achievements remaining tab
-- TODO: Allow automatic use/destruction of holiday 'junk' items
-- TODO: TomCats-Arrows to close in on target
-- TODO: Integrate with map's built-in tracker
-- TODO: Handle zone phase detection and advice
local allowedMaps = {
    WorldMapFrame = true,
    BattlefieldMapFrame = true,
    FlightMapFrame = true
}
local function AddDataProviderToMap(map)
    if (allowedMaps[map:GetName()]) then
        map:AddDataProvider(CreateFromMixins(TomCatsLunarFestivalDataProviderMixin))
    end
end
local function ADDON_LOADED(event, ...)
    if (not WorldMapFrame and _G["WorldMapFrame"]) then
        WorldMapFrame = addon.GetProxy(_G["WorldMapFrame"])
        AddDataProviderToMap(WorldMapFrame)
    end
    if (not BattlefieldMapFrame and _G["BattlefieldMapFrame"]) then
        BattlefieldMapFrame = addon.GetProxy(_G["BattlefieldMapFrame"])
        AddDataProviderToMap(BattlefieldMapFrame)
    end
    if (not FlightMapFrame and _G["FlightMapFrame"]) then
        FlightMapFrame = addon.GetProxy(_G["FlightMapFrame"])
        AddDataProviderToMap(FlightMapFrame)
    end
end
local function zoneTweak()
    if (BattlefieldMapFrame) then
        if GetCVar("showBattlefieldMinimap") == "1" then
            local mapID = MapUtil.GetDisplayableMapForPlayer()
            BattlefieldMapFrame:SetMapID(mapID)
        end
    end
end
local function zoneTweakRecheck()
    if (BattlefieldMapFrame) then
        local mapID1 = MapUtil.GetDisplayableMapForPlayer()
        local mapID2 = BattlefieldMapFrame:GetMapID()
        if (mapID1 ~= mapID2) then
            zoneTweak()
        end
        C_Timer.After(1, zoneTweakRecheck)
    else
        C_Timer.After(5, zoneTweakRecheck)
    end
end
addon.RegisterEvent("ADDON_LOADED", ADDON_LOADED)
TCL.Events.RegisterEvent("ZONE_CHANGED", zoneTweak)
TCL.Events.RegisterEvent("ZONE_CHANGED_INDOORS", zoneTweak)
TCL.Events.RegisterEvent("NEW_WMO_CHUNK", zoneTweak)
zoneTweakRecheck()
if (TomCats and TomCats.Register) then
    TomCats:Register(
        {
            name = "Lunar Festival",
            version = "01.00.26"
        }
    )
end
